#version 120
// (C) 2010 Dmytry Lavrov. All rights reserved.
uniform float brightness;
uniform float t;

void main(void)
{
	float phase=0.1*t;
	vec2 cs1=vec2(cos(phase*0.12345),-sin(phase*0.12345));

	vec3 rpos=vec3(gl_Vertex.x*cs1.x+gl_Vertex.z*cs1.y, gl_Vertex.y, gl_Vertex.z*cs1.x-gl_Vertex.x*cs1.y);
	//vec3 rpos=gl_Vertex.xyz;

	float r=length(rpos.xy)+0.01;
	vec2 base = rpos.xy*(1.0/r);

	float u=mod(rpos.z-phase*(0.95+0.05*gl_Vertex.x), 1.0);

	float spin_phase=12.0*pow(1.0-u,3.0);
	//float spin_phase=0;

  vec2 cs=vec2(cos(phase+spin_phase),-sin(phase+spin_phase));

  vec2 rbase=vec2(base.x*cs.x+base.y*cs.y, base.y*cs.x-base.x*cs.y);

  vec3 vert=vec3(rbase*u*u*3.0, 5.0-1.0/(u+0.1))*r;

  vec3 vel=vec3(-rpos.xy*cs.y, r*cs.x);

  vec4 camera_pos = gl_ModelViewMatrixInverse[3];
	vec4 pos = gl_ModelViewProjectionMatrix * vec4(vert, 1.0);

	vec3 delta=(gl_ModelViewMatrix * vec4(vert, 1.0)).xyz;

	//float br=dot(normalize(gl_Vertex-camera_pos).xyz,vel);
	float br=abs(gl_Vertex.x*cs.x+gl_Vertex.z*cs.y)*pow(1-u,0.5);
	//float br=0.1;

	float l=dot(delta,delta);
	gl_Position=pos;
	float q=exp2(255.0*gl_Color.a-119.0);
	vec3 col=gl_Color.rgb*(q*brightness*br/(l+0.1));
	gl_FrontColor=vec4(col.r,col.g*br,col.b*br*br,1.0);
	//gl_FrontColor=vec4(col.xyz*abs(gl_Vertex.xyz),1.0);
}
