#version 120
// (C) Dmytry Lavrov. All rights reserved.
attribute vec3 fpos;

uniform vec3 brightness;
uniform float texture_offset;
uniform float texture_scale;
uniform float color_phase;
uniform sampler2D texture;


varying vec3 delta;

/*
float BellCurve(float t){
	return exp(-t*t);
}

vec3 AmpColor(float t){/// 0..1 --> infrared...ultraviolet
	return vec3(BellCurve((t-0.25)*6.0)+0.001,BellCurve((t-0.4)*6.0)+0.01,BellCurve((t-0.75)*6.0));
}*/

/*
vec3 AmpColor(float t){
	return vec3(max(cos(t+3.0),0.0), max(cos(t+1.5),0.0), max(cos(t),0.0) );
}*/


vec3 AmpColor(float t_){
	float t=color_phase+t_;
	return pow(vec3(cos(t+4.1)*0.5+0.5, cos(t+2.05)*0.5+0.5, cos(t)*0.5+0.5),vec3(2.3));
}

void main(void)
{
	vec2 tp=vec2(abs(fpos.z), texture_offset-(sign(fpos.z)*atan(fpos.y,fpos.x)+3.1415926)*0.1*texture_scale);//vec2(gl_Color.x, texture_offset-gl_Color.y*0.2);

	vec3 tv=texture2DLod(texture, tp, 0.0).xyz;
	float r=tv.y*2.0;//tv.x+tv.y+tv.z;

	vec4 pos=vec4((gl_Vertex.xyz*0.95+fpos*0.05)*(1.0+r*0.02),1.0);
	gl_Position = gl_ModelViewProjectionMatrix * pos;
 	delta=(gl_ModelViewMatrix * pos).xyz;

	vec3 col=AmpColor(r*0.3);
	gl_FrontColor=vec4(col*sqrt(brightness),1.0);
}

